unit ufunktest;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  Tffunktest = class(TForm)
    Label1: TLabel;
    BitBtn1: TBitBtn;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    el: TEdit;
    eb: TEdit;
    eh: TEdit;
    bquadervolumen: TButton;
    ev: TEdit;
    eradius: TEdit;
    ehoehe: TEdit;
    bzylvolumen: TButton;
    ezylvolumen: TEdit;
    es1: TEdit;
    es2: TEdit;
    es3: TEdit;
    bdreieck: TButton;
    eflaeche: TEdit;
    eereignis: TEdit;
    bereignis: TButton;
    eereignisausgabe: TEdit;
    en: TEdit;
    bpartsumme: TButton;
    epartsumme: TEdit;
    efn: TEdit;
    bfakultaet: TButton;
    efakultaet: TEdit;
    efib: TEdit;
    bfib: TButton;
    efibausgabe: TEdit;
    procedure bquadervolumenClick(Sender: TObject);
    procedure bzylvolumenClick(Sender: TObject);
    procedure bdreieckClick(Sender: TObject);
    procedure bereignisClick(Sender: TObject);
    procedure bpartsummeClick(Sender: TObject);
    procedure bfakultaetClick(Sender: TObject);
    procedure bfibClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  ffunktest: Tffunktest;

implementation

{$R *.dfm}

procedure Tffunktest.bquadervolumenClick(Sender: TObject);
VAR l,b,h,v : REAL;

  FUNCTION Grundflaeche(a,b:REAL):REAL;
  BEGIN
   Grundflaeche:=a*b;
  END;

  FUNCTION Volumen(l,b,h:REAL):REAL;
  BEGIN
   Volumen:=Grundflaeche(l,b)*h;
  END;

begin
 l:=STRTOFLOAT(el.text);
 b:=STRTOFLOAT(eb.Text);
 h:=STRTOFLOAT(eh.Text);
 v:=Volumen(l,b,h);
 ev.Text:=FLOATTOSTRF(v,ffnumber,8,2);
end;

procedure Tffunktest.bzylvolumenClick(Sender: TObject);
VAR radius,hoehe,v : REAL;

  FUNCTION Grundflaeche(r,h:REAL):REAL;
  BEGIN
   Grundflaeche:=Pi*SQR(r)*h;
  END;

  FUNCTION Volumen(r,h:REAL):REAL;
  BEGIN
   Volumen:=Grundflaeche(r,h)*h;
  END;

begin
 radius:=STRTOFLOAT(eradius.text);
 hoehe:=STRTOFLOAT(ehoehe.Text);
 v:=Volumen(radius,hoehe);
 ezylvolumen.Text:=FLOATTOSTRF(v,ffnumber,8,2);
end;

procedure Tffunktest.bdreieckClick(Sender: TObject);
VAR a,b,c,F : REAL;

  FUNCTION Umfang(a,b,c : REAL):REAL;
  BEGIN
   Umfang :=a+b+c;
  END;

  FUNCTION s(a,b,c : REAL):REAL;
  BEGIN
   s:=Umfang(a,b,c)/2;
  END;

  FUNCTION Dreieck_Flaeche(a,b,c :REAL):REAL;
  BEGIN
   Dreieck_Flaeche:=SQRT(s(a,b,c)*(s(a,b,c)-a)*(s(a,b,c)-b)*(s(a,b,c)-c));
  END;

begin
 // Dreiecksflche
 a:=STRTOFLOAT(es1.text);
 b:=STRTOFLOAT(es2.text);
 c:=STRTOFLOAT(es3.text);
 F:=Dreieck_Flaeche(a,b,c);
 eflaeche.Text:=FLOATTOSTRF(F,ffnumber,8,2);
end;

procedure Tffunktest.bereignisClick(Sender: TObject);
VAR Ampelfarbe : STRING;

  FUNCTION Ereignis(Farbe:STRING):STRING;
  BEGIN
   IF Farbe='rot' THEN Ereignis:='Halt'
                  ELSE IF Farbe='gelb' THEN Ereignis:='Kreuzung rumen'
                                       ELSE IF Farbe='grn' THEN Ereignis:='Freie Fahrt'
                                                            ELSE Ereignis:='NIL';
  END;

begin
 Ampelfarbe:=eereignis.text;
 eereignisausgabe.Text:=Ereignis(Ampelfarbe);
end;

procedure Tffunktest.bpartsummeClick(Sender: TObject);
VAR n, ps : INTEGER;

  FUNCTION Partialsumme(n : INTEGER):INTEGER;
  VAR s,i : INTEGER;
  BEGIN
   s:=0;
   FOR i:=1 TO n DO s:=s+i;
   Partialsumme:=s;
  END;

begin
 n:=STRTOINT(en.Text);
 ps:=Partialsumme(n);
 epartsumme.Text:=INTTOSTR(ps);
end;

procedure Tffunktest.bfakultaetClick(Sender: TObject);
VAR n, fak : INTEGER;

  FUNCTION nFakultaet(n : INTEGER):INTEGER;
  VAR p,i : INTEGER;
  BEGIN
   p:=1;
   FOR i:=1 TO n DO p:=p*i;
   nFakultaet:=p;
  END;

begin
 n:=STRTOINT(efn.Text);
 fak:=nFakultaet(n);
 efakultaet.Text:=INTTOSTR(fak);
end;

procedure Tffunktest.bfibClick(Sender: TObject);
VAR n, fib : INTEGER;

  FUNCTION Fibonacci(n : INTEGER):INTEGER;
  VAR anzahl,m0,m1,i : INTEGER;
  BEGIN
   m0:=0;m1:=1; anzahl:=0;
   FOR i:=1 TO n DO
    BEGIN
     anzahl:=m0+m1;
     m0:=m1;
     m1:=anzahl;
    END;
   Fibonacci:=anzahl;
  END;

begin
 n:=STRTOINT(efib.Text);
 fib:=Fibonacci(n);
 efibausgabe.Text:=INTTOSTR(fib);
end;

end.
